//+------------------------------------------------------------------+
//|                                                   ZigZagFibo.mq4 |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
input string s1="   ZigZag Parameters";
input int InpDepth=12;     // Depth
input int InpDeviation=5;  // Deviation
input int InpBackstep=3;   // Back
input color ZigZagColor=clrRed;
input int ZigZagWidth=2;
input color FiboColor=clrYellow;
input int FiboWidth=1;
input double StartLot=0.01;
input int StopLoss=500;
input int magic=469019;
input int TPDistanceForAdd=50;

double L0;
double L100;
double L161;
double L261;
double L423;
datetime TF100;
datetime TF0;

string pref="ZZF";
datetime T0;


 int XT=20;
int YT=20;

int RowHight=20;

int stat;
 //int FirsColWidth=80;
 //int FirstRowHight=20;
 int OtherColWidth=120;

 color HABullColor=clrWhite;
 color HABearColor=clrRed;
 color BuyColor=clrLightGreen;
 color SellColor=clrLightPink;
 color SumColor=clrLightYellow;
color BordColopr=clrDarkGray;

color PanelColor=clrLightGray;
color NeutrColor=clrLightYellow;
color RetrColor=clrLightGreen;
int WGreed=2;
int FS=8;
string FontName="Arial";
color TextColor=clrBlack;

int ProfitTradesCount;
int LossTradeCount;
double SumProfit;
double SumLoss;
double BestProfit;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   //EventSetTimer(60);
   EraseAll(pref);
   T0=0;
   L0=0;
   L100=0;
      
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
  // EventKillTimer();
     EraseAll(pref); 
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
      
      if (T0<Time[0])
      {
         if (!IsMarket()) BuildFibo();
         T0=Time[0];
      }   
      if (!IsMarket())
      {
        datetime tc=TF0;
        if (TF100>tc) tc=TF100;
        if (!IsClosed(tc))
        {
            StandPendings();
        }     
      }
      Close23();  
      StandTP(); 
      DeleteAcross0();
      CalcAll();
      OutTable();
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---
   
  }
//+------------------------------------------------------------------+
  
  int BuildFibo()
  {
    L0=0;
    L100=0;
    double f1=0;
    double f2=0;
    double f3=0;
    datetime tf1=0;
    datetime tf2=0;
    datetime tf3=0;
    int k=0;
    bool b=true;
    while (b)
    {
        double z=iCustom(_Symbol,0,"ZigZag",InpDepth,InpDeviation,InpBackstep,0,k);
        if ((z>Bid/2)&&(z<2*Bid))
        {
           if (tf1==0)
           {
              tf1=Time[k];
              f1=z;
           }
           else
           {
              if (tf2==0)
              {
                 tf2=Time[k];
                 f2=z;
              }
              else
              {
                  tf3=Time[k];
                  f3=z;
                  b=false;
              }
           }
        }
        k++;
        if (k>300) b=false;
    }
    if (tf3>0)
    {
       DrawFibo(tf1,f1,tf2,f2,tf3,f3);
  
    }
    return(0);
  }
  
  int EraseAll(string pr)
  {
      for (int i=ObjectsTotal()-1;i>=0;i--)
      {
         string st=ObjectName(i); 
         if (StringFind(st,pr,0)==0 )  ObjectDelete(st);
      }
     return(0);
  }  
  
  int DrawFibo(datetime t1,double p1,datetime t2, double p2, datetime t3, double p3)
  {
      int wb=(int)ChartGetInteger(0,CHART_WIDTH_IN_BARS);
      int vb=(int)ChartGetInteger(0,CHART_VISIBLE_BARS);
      
      datetime TL=Time[0]+(wb-vb-1)*PeriodSeconds();
      
      string name;
      string nm=pref+"Fibo";
      EraseAll(nm);
      name=nm+"Z1";
      ObjectCreate(0,name,OBJ_TREND,0,t1,p1,t2,p2);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,ZigZagWidth);
      ObjectSetInteger(0,name,OBJPROP_COLOR,ZigZagColor);
      ObjectSetInteger(0,name,OBJPROP_RAY_RIGHT,false);
  
      name=nm+"Z2";
      ObjectCreate(0,name,OBJ_TREND,0,t2,p2,t3,p3);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,ZigZagWidth);
      ObjectSetInteger(0,name,OBJPROP_COLOR,ZigZagColor);
      ObjectSetInteger(0,name,OBJPROP_RAY_RIGHT,false);
      
      
      if (p2>p3)
      {
          L0=p2;
          TF0=t2;
          L100=p3;
          TF100=t3;
          L161=p3-0.61*(p2-p3);
          L261=p3-1.61*(p2-p3);
          L423=p3-3.23*(p2-p3);
      }
      else
      {
          L0=p2;
          TF0=t2;
          L100=p3;
          TF100=t3;
          L161=p3+0.61*(p3-p2);
          L261=p3+1.61*(p3-p2);
          L423=p3+3.23*(p3-p2);
      
      }
      name=nm+"L0";
      ObjectCreate(0,name,OBJ_HLINE,0,t1,L0);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,FiboWidth);
      ObjectSetInteger(0,name,OBJPROP_COLOR,FiboColor);
      
      name=name+"TXT";
      ObjectCreate(0,name,OBJ_TEXT,0,TL,L0);
      ObjectSetString(0,name,OBJPROP_TEXT,"0");
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1);
      ObjectSetInteger(0,name,OBJPROP_COLOR,FiboColor);
      ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_RIGHT_LOWER);
      
      name=nm+"L100";
      ObjectCreate(0,name,OBJ_HLINE,0,t1,L100);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,FiboWidth);
      ObjectSetInteger(0,name,OBJPROP_COLOR,FiboColor);
      name=name+"TXT";
      ObjectCreate(0,name,OBJ_TEXT,0,TL,L100);
      ObjectSetString(0,name,OBJPROP_TEXT,"100");
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1);
      ObjectSetInteger(0,name,OBJPROP_COLOR,FiboColor);
      ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_RIGHT_LOWER);
      
      name=nm+"L161";
      ObjectCreate(0,name,OBJ_HLINE,0,t1,L161);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,FiboWidth);
      ObjectSetInteger(0,name,OBJPROP_COLOR,FiboColor);
      name=name+"TXT";
      ObjectCreate(0,name,OBJ_TEXT,0,TL,L161);
      ObjectSetString(0,name,OBJPROP_TEXT,"161");
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1);
      ObjectSetInteger(0,name,OBJPROP_COLOR,FiboColor);
      ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_RIGHT_LOWER);
     
      name=nm+"L261";
      ObjectCreate(0,name,OBJ_HLINE,0,t1,L261);
      ObjectSetInteger(0,name,OBJPROP_WIDTH,FiboWidth);
      ObjectSetInteger(0,name,OBJPROP_COLOR,FiboColor);
      name=name+"TXT";
      ObjectCreate(0,name,OBJ_TEXT,0,TL,L261);
      ObjectSetString(0,name,OBJPROP_TEXT,"261");
      ObjectSetInteger(0,name,OBJPROP_WIDTH,1);
      ObjectSetInteger(0,name,OBJPROP_COLOR,FiboColor);
      ObjectSetInteger(0,name,OBJPROP_ANCHOR,ANCHOR_RIGHT_LOWER);
     
      ChartRedraw();
      return(0);
  }
  
 bool IsMarket()
{
    bool b=false;
    for (int i=0;i<OrdersTotal();i++)
    {
       if (OrderSelect(i,SELECT_BY_POS))
       {
           if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
           {
               if ((OrderType()==ORDER_TYPE_BUY)||(OrderType()==ORDER_TYPE_SELL)) b=true;
           }
       }
   }
   return(b);
}

int StandPendings()
{
   if (L0<0.001) return(0);
   if (L100<0.001) return(0);
   if ((L0>L100)&&(Bid>L161)&&(Bid<L100))
   {
      DeleteSellLimits();
      DeleteOldBuyLimits();
      if (!IsBuyLimit(L161)) BuyLimit(L161,StartLot,L161-StopLoss*_Point,L100);
      if (!IsBuyLimit(L261)) BuyLimit(L261,2*StartLot,L261-StopLoss*_Point,0);
      if (!IsBuyLimit(L423)) BuyLimit(L423,4*StartLot,L423-StopLoss*_Point,0);
   
   }
   else
   {
       if ((Bid<L161)&&(Bid>L100))
       {
          DeleteBuyLimits();
          DeleteOldSellLimits();
          if (!IsSellLimit(L161)) SellLimit(L161,StartLot,L161+StopLoss*_Point,L100);
          if (!IsSellLimit(L261)) SellLimit(L261,2*StartLot,L261+StopLoss*_Point,0);
          if (!IsSellLimit(L423)) SellLimit(L423,4*StartLot,L423+StopLoss*_Point,0);
       }

   }
   return(0);

}

int DeleteSellLimits()
{
    for (int i=OrdersTotal()-1;i>=0;i--)
    {
       if (OrderSelect(i,SELECT_BY_POS))
       {
           if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
           {
               if (OrderType()==ORDER_TYPE_SELL_LIMIT) 
               {
                   int o=OrderDelete(OrderTicket());
               }
           }
       }
   }
   return(0);
}

int DeleteBuyLimits()
{
    for (int i=OrdersTotal()-1;i>=0;i--)
    {
       if (OrderSelect(i,SELECT_BY_POS))
       {
           if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
           {
               if (OrderType()==ORDER_TYPE_BUY_LIMIT) 
               {
                   int o=OrderDelete(OrderTicket());
               }
           }
       }
   }
   return(0);
}

int DeleteOldBuyLimits()
{
    for (int i=OrdersTotal()-1;i>=0;i--)
    {
       if (OrderSelect(i,SELECT_BY_POS))
       {
           if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
           {
               if (OrderType()==ORDER_TYPE_BUY_LIMIT) 
               {
                   bool b=true;
                   double op=OrderOpenPrice();
                   if (MathAbs(L161-op)<2*_Point) b=false;
                   if (MathAbs(L261-op)<2*_Point) b=false;
                   if (MathAbs(L423-op)<2*_Point) b=false;
                   if (b) int o=OrderDelete(OrderTicket());
               }
               
           }
       }
   }
   return(0);
}

int DeleteOldSellLimits()
{
    for (int i=OrdersTotal()-1;i>=0;i--)
    {
       if (OrderSelect(i,SELECT_BY_POS))
       {
           if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
           {
               if (OrderType()==ORDER_TYPE_SELL_LIMIT) 
               {
                   bool b=true;
                   double op=OrderOpenPrice();
                   if (MathAbs(L161-op)<2*_Point) b=false;
                   if (MathAbs(L261-op)<2*_Point) b=false;
                   if (MathAbs(L423-op)<2*_Point) b=false;
                   if (b) int o=OrderDelete(OrderTicket());
               }
               
           }
       }
   }
   return(0);
}

int BuyLimit(double price, double lotsize, double stoploss, double takeprofit)
{
 // Print("BuyL  price = ",price,"  sl = ",stoploss,"  tp = ",takeprofit,"  bid = ",Bid);
  double p=NormalizeDouble(price,_Digits);
  int dp=(int)MarketInfo(Symbol(),MODE_STOPLEVEL);
  int n=2;
  if (MarketInfo(Symbol(),MODE_LOTSTEP)==0.1) n=1;
  if (MarketInfo(Symbol(),MODE_LOTSTEP)==1.0) n=0;
  double lot=NormalizeDouble(lotsize,n);
  if (lot<MarketInfo(Symbol(),MODE_MINLOT)) lot=NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),n);
  string cm="";
  int mg=magic;
  double stopl=0;
  if (stoploss>0.001)
  { 
      stopl=NormalizeDouble(stoploss,_Digits);
      if ((p-stopl)<(dp*_Point)) stopl=NormalizeDouble(p-(dp+1)*_Point,_Digits); 
  }
  double tp=NormalizeDouble(takeprofit,_Digits);
  if (tp>0.001)
  {
       if (tp-p<dp*_Point) tp=NormalizeDouble(p+(dp+1)*_Point,_Digits);
  }
  int k=OrderSend(Symbol(),OP_BUYLIMIT,lot,p,3,stopl,tp,cm,mg,0); 
  if (k<0)
  {
     int v=0;
     while (k<0&&v<10)
     {
        Print ("BuyLimit error open ",GetLastError());
        Sleep(200);
        RefreshRates();
       
        k=OrderSend(Symbol(),OP_BUYLIMIT,lot,p,3,stopl,tp,cm,mg,0); 
        v++;
     }
  } 
  Sleep(200);
  return(0);
}
int SellLimit(double price, double lotsize, double stoploss, double takeprofit)
{
//  Print("SellL  price = ",price,"  sl = ",stoploss,"  tp = ",takeprofit,"  bid = ",Bid);
  double p=NormalizeDouble(price,_Digits);
  int dp=(int)MarketInfo(Symbol(),MODE_STOPLEVEL);
  int n=2;
  if (MarketInfo(Symbol(),MODE_LOTSTEP)==0.1) n=1;
  if (MarketInfo(Symbol(),MODE_LOTSTEP)==1.0) n=0;
  double lot=NormalizeDouble(lotsize,n);
  if (lot<MarketInfo(Symbol(),MODE_MINLOT)) lot=NormalizeDouble(MarketInfo(Symbol(),MODE_MINLOT),n);
  string cm="";
  int mg=magic;
  double stopl=0;
  if (stoploss>0.001)
  {
     stopl=NormalizeDouble(stoploss,_Digits);
 
     if ((stopl-p)<(dp*_Point))stopl=NormalizeDouble(p+(dp+1)*_Point,_Digits); 
  }   
  double tp=NormalizeDouble(takeprofit,_Digits);
  if (tp>0.001)
  {
      if (p-tp<dp*_Point) tp=NormalizeDouble(p-(dp+1)*_Point,_Digits);
  }
 // Print("<><><>  p = ",p,"  sl = ",stopl,"  tp = ",tp,"  bid = ",Bid);
  int k=OrderSend(Symbol(),OP_SELLLIMIT,lot,p,3,stopl,tp,cm,mg,0); 
  if (k<0)
  {
     int v=0;
     while (k<0&&v<10)
     {
        Print ("Sell Limit error open ",GetLastError());
        Sleep(200);
        RefreshRates();
       
        k=OrderSend(Symbol(),OP_SELLLIMIT,lot,p,3,stopl,tp,cm,mg,0); 
        v++;
     }
  } 
  Sleep(200);
  return(0);
}

bool IsBuyLimit(double p)
{
    bool b=false;
    for (int i=0;i<OrdersTotal();i++)
    {
       if (OrderSelect(i,SELECT_BY_POS))
       {
           if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
           {
               if (OrderType()==ORDER_TYPE_BUY_LIMIT) 
               {
                   if (MathAbs(OrderOpenPrice()-p)<2*_Point) b=true;
               }
           }
       }
   }
   return(b);
}

bool IsSellLimit(double p)
{
    bool b=false;
    for (int i=0;i<OrdersTotal();i++)
    {
       if (OrderSelect(i,SELECT_BY_POS))
       {
           if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
           {
               if (OrderType()==ORDER_TYPE_SELL_LIMIT) 
               {
                   if (MathAbs(OrderOpenPrice()-p)<2*_Point) b=true;
               }
           }
       }
   }
   return(b);
}

 int Cell(int col, int row, string txt, color cl, color bcl)
  {
     string name;
     int x=XT;
     int y=YT;
     if (col>0)
     {
        x=XT+OtherColWidth+(col-1)*OtherColWidth;
     } 
     if (row>0) y=YT+RowHight+(row-1)*RowHight;  
     int wt=OtherColWidth;
     if (col>0) wt=OtherColWidth;
     int ht=RowHight;
     if (row==0) ht=RowHight;
     name=pref+"Cell_"+IntegerToString(col)+"_"+IntegerToString(row);
     if (ObjectFind(0,name)!=0)
     {
        ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,0,0,0);
       
        
        ObjectSetInteger(0,name,OBJPROP_XSIZE,wt);
        ObjectSetInteger(0,name,OBJPROP_YSIZE,ht);
        ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bcl);
        ObjectSetInteger(0,name,OBJPROP_BORDER_COLOR,BordColopr);
        ObjectSetInteger(0,name,OBJPROP_WIDTH,WGreed);
        ObjectSetInteger(0,name,OBJPROP_BACK,false);
     }
     ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
     ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
     
     ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bcl);
     
     name=name+"TXT";
     if (ObjectFind(0,name)!=0)
     {
        ObjectCreate(0,name,OBJ_LABEL,0,0,0);
       
        
        ObjectSetInteger(0,name,OBJPROP_FONTSIZE,FS);
        ObjectSetInteger(0,name,OBJPROP_BACK,false);
        ObjectSetString(0,name,OBJPROP_FONT,FontName);
     }
     ObjectSetString(0,name,OBJPROP_TEXT,txt);
     ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
     ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y+2); 
     if (row==0)  ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y+2+RowHight-RowHight); 
     ObjectSetInteger(0,name,OBJPROP_COLOR,cl);
  
  
  
     return(0);
  } 

  int CellW(int col, int row, string txt, color cl, color bcl,int w)
  {
     string name;
     int x=XT;
     int y=YT;
     if (col>0)
     {
        x=XT+OtherColWidth+(col-1)*OtherColWidth;
     } 
     if (row>0) y=YT+RowHight+(row-1)*RowHight;  
     int wt=OtherColWidth*w;
     if (col>0) wt=OtherColWidth;
     int ht=RowHight;
     if (row==0) ht=RowHight;
     name=pref+"Cell_"+IntegerToString(col)+"_"+IntegerToString(row);
     if (ObjectFind(0,name)!=0)
     {
        ObjectCreate(0,name,OBJ_RECTANGLE_LABEL,0,0,0);
       
        
        ObjectSetInteger(0,name,OBJPROP_XSIZE,wt);
        ObjectSetInteger(0,name,OBJPROP_YSIZE,ht);
        ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bcl);
        ObjectSetInteger(0,name,OBJPROP_BORDER_COLOR,BordColopr);
        ObjectSetInteger(0,name,OBJPROP_WIDTH,WGreed);
        ObjectSetInteger(0,name,OBJPROP_BACK,false);
     }
     ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
     ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y);
     
     ObjectSetInteger(0,name,OBJPROP_BGCOLOR,bcl);
     
     name=name+"TXT";
     if (ObjectFind(0,name)!=0)
     {
        ObjectCreate(0,name,OBJ_LABEL,0,0,0);
       
        
        ObjectSetInteger(0,name,OBJPROP_FONTSIZE,FS);
        ObjectSetInteger(0,name,OBJPROP_BACK,false);
        ObjectSetString(0,name,OBJPROP_FONT,FontName);
     }
     ObjectSetString(0,name,OBJPROP_TEXT,txt);
     ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x);
     ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y+2); 
     if (row==0)  ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y+2+RowHight-RowHight); 
     ObjectSetInteger(0,name,OBJPROP_COLOR,cl);
  
  
  
     return(0);
  } 
  
  int CalcAll()
  {
     ProfitTradesCount=0;
     LossTradeCount=0;
     SumProfit=0;
     SumLoss=0;
     BestProfit=0;
     for (int i=0;i<OrdersTotal();i++)
     {
        if (OrderSelect(i,SELECT_BY_POS))
        {
           if ((OrderType()==ORDER_TYPE_BUY)||(OrderType()==ORDER_TYPE_SELL))
           {
               if (OrderProfit()>=0)
               {
                  ProfitTradesCount++;
                  SumProfit=SumProfit+OrderProfit();
                  if (OrderProfit()>BestProfit) BestProfit=OrderProfit();
               }
               else
               {
                  LossTradeCount++;
                  SumLoss=SumLoss+OrderProfit();
               }
               
           }
        
        }
     }
     return(0);
  }
  
  int OutTable()
  {
     Cell(0,0,"   Symbol",TextColor,PanelColor);
     Cell(1,0,"  "+_Symbol,TextColor,NeutrColor);
     Cell(0,1,"   Price",TextColor,PanelColor);
     Cell(1,1,"  "+DoubleToString(Bid,_Digits),TextColor,NeutrColor);
     Cell(0,2,"   Spread",TextColor,PanelColor);
     double sp=0;
     if (_Point>0) sp=(Ask-Bid)/(10*_Point);
     Cell(1,2,"    "+DoubleToString(sp,1),TextColor,NeutrColor);
     Cell(0,3," Today HighToLow",TextColor,PanelColor);
     sp=(iHigh(_Symbol,PERIOD_D1,0)-iLow(_Symbol,PERIOD_D1,0))/(10*_Point);
     Cell(1,3,"    "+DoubleToString(sp,1),TextColor,NeutrColor);
     Cell(0,4," Yesterday HighToLow",TextColor,PanelColor);
     sp=(iHigh(_Symbol,PERIOD_D1,1)-iLow(_Symbol,PERIOD_D1,1))/(10*_Point);
     Cell(1,4,"    "+DoubleToString(sp,1),TextColor,NeutrColor);
     Cell(0,5,"   Bar Time Left",TextColor,PanelColor);
     Cell(1,5," "+TimeToString(Time[0],TIME_DATE|TIME_MINUTES),TextColor,NeutrColor);
     Cell(0,6,"   Total Orders",TextColor,PanelColor);
     Cell(1,6,"    "+IntegerToString(ProfitTradesCount+LossTradeCount),TextColor,NeutrColor);
     Cell(0,7,"   Profitable Trades",TextColor,PanelColor);
     Cell(1,7,"    "+IntegerToString(ProfitTradesCount),TextColor,NeutrColor);
     Cell(0,8,"   Loss Trades",TextColor,PanelColor);
     Cell(1,8,"    "+IntegerToString(LossTradeCount),TextColor,NeutrColor); 
     Cell(0,9,"   noLoss/Profit",TextColor,PanelColor);
     Cell(1,9,"    ",TextColor,NeutrColor); 
     Cell(0,10,"   Success Rate",TextColor,PanelColor);
     sp=0;
     if ((ProfitTradesCount>0)&&(LossTradeCount==0)) sp=100;
     if ((ProfitTradesCount>0)&&(LossTradeCount>0)) sp=SumProfit/(0-SumLoss);
     Cell(1,10,"    "+DoubleToString(sp,2),TextColor,NeutrColor); 
     Cell(0,11,"   Best Profit",TextColor,PanelColor);
     Cell(1,11,"    "+DoubleToString(BestProfit,2),TextColor,NeutrColor); 
     Cell(0,12,"   Average Profit",TextColor,PanelColor);
     sp=0;
     if (ProfitTradesCount>0) sp=SumProfit/ProfitTradesCount;
     Cell(1,12,"    "+DoubleToString(sp,2),TextColor,NeutrColor); 
     Cell(0,13,"   Average Loss",TextColor,PanelColor);
     sp=0;
     if (LossTradeCount>0) sp=SumLoss/LossTradeCount;
     Cell(1,13,"    "+DoubleToString(sp,2),TextColor,NeutrColor); 
     double b=AccountBalance();
     double e=AccountEquity();
     Cell(0,14,"   Account Deposit",TextColor,PanelColor);
     Cell(1,14,"    "+DoubleToString(b,2),TextColor,NeutrColor); 
     Cell(0,15,"   Account Loss/Profit",TextColor,PanelColor);
     Cell(1,15,"    "+DoubleToString(e-b,2),TextColor,NeutrColor); 
     
     return(0);
  }
  
  int Close23()
  {
     bool p1market=false;
     bool p1pend=false;
     bool p2pend=false;
     bool p3pend=false;
     if (L0>L100)  //  Check BUY  BUYLIMIT
     {
        for (int i=0;i<OrdersTotal();i++)
        {
           if (OrderSelect(i,SELECT_BY_POS))
           {
              if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
              {
                 if (OrderType()==ORDER_TYPE_BUY)
                 {
                    if (MathAbs(OrderLots()-StartLot)<0.005) p1market=true;
                 }
                 if (OrderType()==ORDER_TYPE_BUY_LIMIT)
                 {
                    if (MathAbs(OrderLots()-StartLot)<0.005) p1pend=true;
                    if (MathAbs(OrderLots()-2*StartLot)<0.005) p2pend=true;
                    if (MathAbs(OrderLots()-4*StartLot)<0.005) p3pend=true;
                 }
                 if ((!p1pend)&&(!p1market))
                 {
                    if (p2pend||p3pend)
                    {
                        DeleteBuyLimits();
                        DeleteSellLimits();
                        BuildFibo();  
                 
                    }
                 
                 }
                 
              }
           }
        }
     }
     if (L0<L100)  //  Check SELL  SELLLIMIT
     {
        for (int i=0;i<OrdersTotal();i++)
        {
           if (OrderSelect(i,SELECT_BY_POS))
           {
              if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
              {
                 if (OrderType()==ORDER_TYPE_SELL)
                 {
                    if (MathAbs(OrderLots()-StartLot)<0.005) p1market=true;
                 }
                 if (OrderType()==ORDER_TYPE_SELL_LIMIT)
                 {
                    if (MathAbs(OrderLots()-StartLot)<0.005) p1pend=true;
                    if (MathAbs(OrderLots()-2*StartLot)<0.005) p2pend=true;
                    if (MathAbs(OrderLots()-4*StartLot)<0.005) p3pend=true;
                 }
                 if ((!p1pend)&&(!p1market))
                 {
                    if (p2pend||p3pend)
                    {
                        DeleteBuyLimits();
                        DeleteSellLimits();
                        BuildFibo();  
                 
                    }
                 
                 }
                 
              }
           }
        }
     }
     
     
     return(0);
  }
  
  int StandTP()
  {
   //  double expsell=GiveExpSellPrice();
 //    double expbuy=GiveExpBuyPrice();
     bool p1market=false;
     bool p2market=false;
     bool p3market=false;
    
     if (L0>L100)  //  Check BUY  
     {
        for (int i=0;i<OrdersTotal();i++)
        {
           if (OrderSelect(i,SELECT_BY_POS))
           {
              if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
              {
                 if (OrderType()==ORDER_TYPE_BUY)
                 {
                    if (MathAbs(OrderLots()-StartLot)<0.005) p1market=true;
                    if (MathAbs(OrderLots()-2*StartLot)<0.005) p2market=true;
                    if (MathAbs(OrderLots()-3*StartLot)<0.005) p3market=true;
                 }
              }
           }
        }
        if (p1market&&p2market)
        {
           double expbuy=GiveExpBuyPrice();
           if (expbuy>0.01)
           {
              double tp=NormalizeDouble(expbuy+TPDistanceForAdd*_Point,_Digits);
              for (int i=0;i<OrdersTotal();i++)
              {
                  if (OrderSelect(i,SELECT_BY_POS))
                  {
                     if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
                     {
                         if (OrderType()==ORDER_TYPE_BUY)
                         {
                             if (MathAbs(OrderTakeProfit()-tp)>2*_Point)
                             {
                                 int o=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0);
                             }
           
                         }
                     }
                  }
              }
           }
        }
     }
     if (L0<L100)  //  Check SELL  
     {
        for (int i=0;i<OrdersTotal();i++)
        {
           if (OrderSelect(i,SELECT_BY_POS))
           {
              if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
              {
                 if (OrderType()==ORDER_TYPE_SELL)
                 {
                    if (MathAbs(OrderLots()-StartLot)<0.005) p1market=true;
                    if (MathAbs(OrderLots()-2*StartLot)<0.005) p2market=true;
                    if (MathAbs(OrderLots()-3*StartLot)<0.005) p3market=true;
                 }
              }
           }
        }
        if (p1market&&p2market)
        {
           double expsell=GiveExpSellPrice();
           if (expsell>0.01)
           {
              double tp=NormalizeDouble(expsell-TPDistanceForAdd*_Point,_Digits);
              for (int i=0;i<OrdersTotal();i++)
              {
                  if (OrderSelect(i,SELECT_BY_POS))
                  {
                     if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
                     {
                         if (OrderType()==ORDER_TYPE_SELL)
                         {
                             if (MathAbs(OrderTakeProfit()-tp)>2*_Point)
                             {
                                 int o=OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0);
                             }
           
                         }
                     }
                  }
              }
           }
        } 
   
        
     }
     
     
     return(0);
  }
  
  double GiveExpSellPrice()
  {
       double p=0;
       double lottotal=0;
       double prmultlot=0;
       for (int i=0;i<OrdersTotal();i++)
       {
           if (OrderSelect(i,SELECT_BY_POS))
           {
              if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
              {
                 if (OrderType()==ORDER_TYPE_SELL)
                 {
                    lottotal=lottotal+OrderLots();
                    prmultlot=prmultlot+OrderLots()*OrderOpenPrice();
                 
                 }
              }
           } 
        }   
        if (lottotal>0.001)
        {
           p=prmultlot/lottotal;
        }        
       
   /*  int w=(int)ChartGetInteger(0,CHART_WINDOWS_TOTAL);
     if (w>0)
     {
        int we=-1;
        for (int i=1;i<w;i++)
        {
           string indname=ChartIndicatorName(0,i,0); 
           if (indname=="Exposure")
           {
              we=i;
              for (int j=0;j<ObjectsTotal(0,we);j++)
              {
                 string oname=ObjectName(0,j,we);
                 if (StringFind(oname,"Line")==0)
                 {
                     string st1=StringSubstr(oname,5,100);
                     int k=StringFind(st1,"_");
                     if (k>0)
                     {
                         string st2=StringSubstr(st1,0,k);
                         string st3=StringSubstr(st1,k+1,100);
                         if (st3=="0")
                         {
                             if (ObjectGetString(0,oname,OBJPROP_TEXT)==_Symbol)
                             {
                                 string on2="Line_"+st2+"_5";
                                 if (ObjectFind(0,on2)==we)
                                 {
                                     p=StringToDouble(ObjectGetString(0,on2,OBJPROP_TEXT));
                                 }   
                             }
                         }
                     }    
                 
                 }
           
           
              }
           }
  
        }
     }*/
     return(p);
  }
  
  double GiveExpBuyPrice()
  {
       double p=0;
       double lottotal=0;
       double prmultlot=0;
       for (int i=0;i<OrdersTotal();i++)
       {
           if (OrderSelect(i,SELECT_BY_POS))
           {
              if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
              {
                 if (OrderType()==ORDER_TYPE_BUY)
                 {
                    lottotal=lottotal+OrderLots();
                    prmultlot=prmultlot+OrderLots()*OrderOpenPrice();
                 
                 }
              }
           } 
        }   
        if (lottotal>0.001)
        {
           p=prmultlot/lottotal;
        }        
  /*   int w=(int)ChartGetInteger(0,CHART_WINDOWS_TOTAL);
     if (w>0)
     {
        int we=-1;
        for (int i=1;i<w;i++)
        {
           string indname=ChartIndicatorName(0,i,0); 
           if (indname=="Exposure")
           {
              we=i;
              for (int j=0;j<ObjectsTotal(0,we);j++)
              {
                 string oname=ObjectName(0,j,we);
                 if (StringFind(oname,"Line")==0)
                 {
                     string st1=StringSubstr(oname,5,100);
                     int k=StringFind(st1,"_");
                     if (k>0)
                     {
                         string st2=StringSubstr(st1,0,k);
                         string st3=StringSubstr(st1,k+1,100);
                         if (st3=="0")
                         {
                             if (ObjectGetString(0,oname,OBJPROP_TEXT)==_Symbol)
                             {
                                 string on2="Line_"+st2+"_3";
                                 if (ObjectFind(0,on2)==we)
                                 {
                                     p=StringToDouble(ObjectGetString(0,on2,OBJPROP_TEXT));
                                 }   
                             }
                         }
                     }    
                 
                 }
           
           
              }
           }
  
        }  
     } */
     return(p);
  }
  
  int DeleteAcross0()
  {
      if (L0>L100)
      {
         if (Bid>L0)
         {
            if (!IsMarket())
            {
                DeleteBuyLimits();
                DeleteSellLimits();
                BuildFibo();
            }
      
         }
      }
      if (L0<L100)
      {
         if (Bid<L0)
         {
            if (!IsMarket())
            {
                DeleteBuyLimits();
                DeleteSellLimits();
                BuildFibo();
            }
      
         }
      }
  
  
  
  
      return(0);
  }
  
  bool IsClosed(datetime tc)
  {
      bool b=false;
      for (int i=0;i<OrdersHistoryTotal();i++)
      {
          if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
          {
              if ((OrderSymbol()==_Symbol)&&(OrderMagicNumber()==magic))
              {
                 if ((OrderType()==ORDER_TYPE_BUY)||(OrderType()==ORDER_TYPE_SELL))
                 {
                      if (OrderOpenTime()>=tc) b=true;
          
                 }
              }
          }
      }
      return(b);
  }